#pragma once

#include "define.h"
#include "Server.h"
#include "PlayingCards.h"
#include <vector>
#include <array>

enum roomStatus_t :char {
	Waiting,
	playing
};

const int roomPlayerLimit = 3;

class Room
{
public:
	Room() = delete;
	Room(roomID_t rid, playerID_t pid);
	~Room();

	roomID_t getID() const { return m_id; };
	roomStatus_t getStatus() const { return m_roomStatus; }
	const std::vector<playerID_t>& getPlayerIDList() const { return m_PIDList; }
	size_t getSize() const { return m_PIDList.size(); }
	// void setStatus(roomStatus_t status) { roomStatus = status; }
	bool full() const { return m_PIDList.size() >= roomPlayerLimit; }
public:
	bool playerJoin(playerID_t pid);
	bool playerLeave(playerID_t pid);

public:
	// ʼ  playing״̬
	void start();
/********** ²ֻڽplaying״̬ſʹ ************/
	
	// õ
	std::array<card_t, 3> getLandCards();
	
	// ID  ûе0
	playerID_t getLandID() { return m_landlord==-1?0:m_PIDList[m_landlord]; }
	
	// õĿҵ
	const std::vector<card_t> &getPlayerCards(playerID_t pid);
	
	// õĿҵʣ
	size_t getPlayerCardsSize(playerID_t pid);
	
	// õǰֵҵID
	playerID_t getThisTurn() { logFile << "ֵ" << m_turn << std::endl; return m_PIDList.at(m_turn); }
	
	// еúʾѾؼٱʾؿ
	bool coll(bool isColl);
	// е
	bool isColledLand() { return m_first != -1; }
	// ˳Ϊ棬򷵻ؼ
	bool grab(bool isGrab);

	// ƣǳƣƳɹ
	// ʱͲϷߴ󲻹ϼ ؼ
	// ըȻǸҳ
	// ƲԲ
	bool popCards(const PlayingCards & cards);

	// ע⣺ƽ׶޷passôؼ
	bool pass();

	// õһ
	const std::vector<card_t> & getLastRoundCards() { return m_lastRoundCards.getVec(); }

	// Ƿƽ׶Σƽ׶Σ
	bool isPopCards() { return m_turn == m_lastPop; }

	// ǷϷѾ
	bool isEndGame() { return m_roomStatus == roomStatus_t::Waiting; }
	//   ص÷
	int settle(playerID_t pid);


public:
	bool operator==(roomID_t rid) { return m_id == rid; }
private:
	int findPlayer(playerID_t pid);
	void doubleMultiple() { m_multiple *= 2; }
	void turnNext() { ++m_turn %= m_PIDList.size(); }
	void setLandlords(int n);
	bool isSubset(const std::vector<card_t> &sub);
	bool removeSubset(const std::vector<card_t> &sub);

	void Refresh();
	void distribution();


	// Ϸȴ״̬
	void endGame();
	
private:
	roomID_t m_id;
	roomStatus_t m_roomStatus;
	std::vector<playerID_t> m_PIDList;
	std::array<card_t, 54> m_cards;
	std::array<std::vector<card_t>, roomPlayerLimit> m_playerCards;
	PlayingCards m_lastRoundCards;   // һ
/*********************************************************/
	int m_first;                   // һе
	bool m_Grad[roomPlayerLimit];  // ʸ
/*********************************************************/
	int m_lastPop;                 // һ/
	int m_turn;                    // ǰֵ
	int m_landlord;                // 
	int m_X;                       // ϵ  ÷ֹʽ X * m (*2)
	uint32_t m_multiple;           // 
};

