/*
* CoolQ SDK for VC++ 
* Api Version 9
* Written by Coxxs & Thanks for the help of orzFly
*/
#pragma once

#include <cstdint>

#define CQAPIVER 9
#define CQAPIVERTEXT "9"

#ifndef CQAPI
#define CQAPI(ReturnType) extern "C" __declspec(dllimport) ReturnType __stdcall
#endif

#define CQEVENT(ReturnType, Name, Size) __pragma(comment(linker, "/EXPORT:" #Name "=_" #Name "@" #Size))\
 extern "C" __declspec(dllexport) ReturnType __stdcall Name

typedef int32_t CQBOOL;


#define EVENT_IGNORE 0          //¼_
#define EVENT_BLOCK 1           //¼_

#define REQUEST_ALLOW 1         //_ͨ
#define REQUEST_DENY 2          //_ܾ

#define REQUEST_GROUPADD 1      //_Ⱥ
#define REQUEST_GROUPINVITE 2   //_Ⱥ

#define CQLOG_DEBUG 0           // ɫ
#define CQLOG_INFO 10           //Ϣ ɫ
#define CQLOG_INFOSUCCESS 11    //Ϣ(ɹ) ɫ
#define CQLOG_INFORECV 12       //Ϣ() ɫ
#define CQLOG_INFOSEND 13       //Ϣ() ɫ
#define CQLOG_WARNING 20        // ɫ
#define CQLOG_ERROR 30          // ɫ
#define CQLOG_FATAL 40          // 


/*
* ˽Ϣ, ɹϢID
* QQID ĿQQ
* msg Ϣ
*/
CQAPI(int32_t) CQ_sendPrivateMsg(int32_t AuthCode, int64_t QQID, const char *msg);
/*
* ȺϢ, ɹϢID
* groupid Ⱥ
* msg Ϣ
*/
CQAPI(int32_t) CQ_sendGroupMsg(int32_t AuthCode, int64_t groupid, const char *msg);

/*
* Ϣ, ɹϢID
* discussid 
* msg Ϣ
*/
CQAPI(int32_t) CQ_sendDiscussMsg(int32_t AuthCode, int64_t discussid, const char *msg);

/*
* Ϣ
* msgid ϢID
*/
CQAPI(int32_t) CQ_deleteMsg(int32_t AuthCode, int64_t msgid);

/*
*  ֻ
* QQID QQ
*/
CQAPI(int32_t) CQ_sendLike(int32_t AuthCode, int64_t QQID);

/*
* ȺԱƳ
* groupid ĿȺ
* QQID QQ
* rejectaddrequest ٽմ˼Ⱥ룬
*/
CQAPI(int32_t) CQ_setGroupKick(int32_t AuthCode, int64_t groupid, int64_t QQID, CQBOOL rejectaddrequest);

/*
* ȺԱ
* groupid ĿȺ
* QQID QQ
* duration Եʱ䣬λΪ롣Ҫд0
*/
CQAPI(int32_t) CQ_setGroupBan(int32_t AuthCode, int64_t groupid, int64_t QQID, int64_t duration);

/*
* ȺԱ
* groupid ĿȺ
* QQID QQ
* setadmin true:ùԱ false:ȡԱ
*/
CQAPI(int32_t) CQ_setGroupAdmin(int32_t AuthCode, int64_t groupid, int64_t QQID, CQBOOL setadmin);

/*
* ȫȺ
* groupid ĿȺ
* enableban true: false:ر
*/
CQAPI(int32_t) CQ_setGroupWholeBan(int32_t AuthCode, int64_t groupid, CQBOOL enableban);

/*
* ȺԱ
* groupid ĿȺ
* anomymous ȺϢ¼յ anomymous 
* duration Եʱ䣬λΪ롣ֽ֧
*/
CQAPI(int32_t) CQ_setGroupAnonymousBan(int32_t AuthCode, int64_t groupid, const char *anomymous, int64_t duration);

/*
* Ⱥ
* groupid ĿȺ
* enableanomymous true: false:ر
*/
CQAPI(int32_t) CQ_setGroupAnonymous(int32_t AuthCode, int64_t groupid, CQBOOL enableanomymous);

/*
* ȺԱƬ
* groupid ĿȺ
* QQID ĿQQ
* newcard Ƭ(ǳ)
*/
CQAPI(int32_t) CQ_setGroupCard(int32_t AuthCode, int64_t groupid, int64_t QQID, const char *newcard);

/*
* Ⱥ˳ , ˽ӿҪϸȨ
* groupid ĿȺ
* isdismiss Ƿɢ true:ɢȺ(Ⱥ) false:˳Ⱥ(ȺԱ)
*/
CQAPI(int32_t) CQ_setGroupLeave(int32_t AuthCode, int64_t groupid, CQBOOL isdismiss);

/*
* ȺԱרͷ ȺȨ
* groupid ĿȺ
* QQID ĿQQ
* newspecialtitle ͷΣҪɾգ
* duration רͷЧڣλΪ롣Чд-1
*/
CQAPI(int32_t) CQ_setGroupSpecialTitle(int32_t AuthCode, int64_t groupid, int64_t QQID, const char *newspecialtitle, int64_t duration);

/*
* ˳
* discussid Ŀ
*/
CQAPI(int32_t) CQ_setDiscussLeave(int32_t AuthCode, int64_t discussid);

/*
* ú
* responseflag ¼յ responseflag 
* responseoperation REQUEST_ALLOW  REQUEST_DENY
* remark Ӻĺѱע
*/
CQAPI(int32_t) CQ_setFriendAddRequest(int32_t AuthCode, const char *responseflag, int32_t responseoperation, const char *remark);

/*
* Ⱥ
* responseflag ¼յ responseflag 
* requesttype¼ REQUEST_GROUPADD  REQUEST_GROUPINVITE
* responseoperation  REQUEST_ALLOW  REQUEST_DENY
* reason ɣ REQUEST_GROUPADD  REQUEST_DENY ʱ
*/
CQAPI(int32_t) CQ_setGroupAddRequestV2(int32_t AuthCode, const char *responseflag, int32_t requesttype, int32_t responseoperation, const char *reason);

/*
* ȡȺԱϢ
* groupid ĿQQȺ
* QQID ĿQQ
* nocache ʹû
*/
CQAPI(const char *) CQ_getGroupMemberInfoV2(int32_t AuthCode, int64_t groupid, int64_t QQID, CQBOOL nocache);

/*
* ȡİϢ
* QQID ĿQQ
* nocache ʹû
*/
CQAPI(const char *) CQ_getStrangerInfo(int32_t AuthCode, int64_t QQID, CQBOOL nocache);

/*
* ־
* priority ȼCQLOG ͷĳ
* category 
* content 
*/
CQAPI(int32_t) CQ_addLog(int32_t AuthCode, int32_t priority, const char *category, const char *content);

/*
* ȡCookies , ˽ӿҪϸȨ
*/
CQAPI(const char *) CQ_getCookies(int32_t AuthCode);

/*
* ȡCsrfToken , ˽ӿҪϸȨ
*/
CQAPI(int32_t) CQ_getCsrfToken(int32_t AuthCode);

/*
* ȡ¼QQ
*/
CQAPI(int64_t) CQ_getLoginQQ(int32_t AuthCode);

/*
* ȡ¼QQǳ
*/
CQAPI(const char *) CQ_getLoginNick(int32_t AuthCode);

/*
* ȡӦĿ¼ص·ĩβ"\"
*/
CQAPI(const char *) CQ_getAppDirectory(int32_t AuthCode);

/*
* ʾ
* errorinfo Ϣ
*/
CQAPI(int32_t) CQ_setFatal(int32_t AuthCode, const char *errorinfo);

/*
* Ϣе(record),ر \data\record\ Ŀ¼µļ
* file յϢеļ(file)
* outformat ӦļʽĿǰ֧ mp3 amr wma m4a spx ogg wav flac
*/
CQAPI(const char *) CQ_getRecord(int32_t AuthCode, const char *file, const char *outformat);
